summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
Diffstat (limited to '')
-rw-r--r--Makefile6
-rw-r--r--README.md28
-rwxr-xr-xgit-precheck94
-rwxr-xr-xgit-sonar445
4 files changed, 284 insertions, 289 deletions
diff --git a/Makefile b/Makefile
index 95538ac..6edd7f4 100644
--- a/Makefile
+++ b/Makefile
@@ -1,4 +1,4 @@
-SOURCE=git-sonar
+SOURCE=git-sonar git-precheck
PREFIX?=/usr/local
PWD=$(shell pwd)
@@ -21,7 +21,9 @@ install: $(SOURCE)
mkdir -p $(PREFIX)/bin
install -m 755 $(SOURCE) $(PREFIX)/bin
+# Link each file separately since the full PWD is needed
develop: $(SOURCE)
@echo 'Symlinking in' $(PREFIX)/bin '...'
mkdir -p $(PREFIX)/bin
- ln -sf $(PWD)/$(SOURCE) $(PREFIX)/bin
+ ln -sf $(PWD)/git-sonar $(PREFIX)/bin
+ ln -sf $(PWD)/git-precheck $(PREFIX)/bin
diff --git a/README.md b/README.md
index cf6a606..c1155d3 100644
--- a/README.md
+++ b/README.md
@@ -48,7 +48,7 @@ ways depending on your shell.
Add to your `.bashrc`
```bash
-export PS1="$PS1\$(git-sonar --bash) "
+export PS1="$PS1\$(git-sonar) "
```
[(note: the `\` escaping the `$` is important)](#ensuring-prompt-execution)
@@ -56,7 +56,7 @@ export PS1="$PS1\$(git-sonar --bash) "
Add to your `.zshrc`
```zsh
-export PROMPT="$PROMPT\$(git-sonar --zsh) "
+export PROMPT="$PROMPT\$(git-sonar) "
```
[(note: the `\` escaping the `$` is important)](#ensuring-prompt-execution)
@@ -67,7 +67,7 @@ Add to your `config.fish`
function fish_prompt
set_color $fish_color_cwd
echo -n (prompt_pwd)
- echo -n (git-sonar --fish)
+ echo -n (git-sonar)
set_color normal
echo -n ' > '
end
@@ -164,20 +164,6 @@ used git-sonar will run `git fetch` asynchronously every 5 minutes.
This will only occur when the prompt is rendered and it will only occur on the
repo you are currently in.
-To use this feature, when setting your prompt, call git-sonar with `--fetch`:
-
-**Bash**
-```bash
-export PS1="$PS1\$(git-sonar --bash --fetch)"
-```
-[(note: the `\` escaping the `$` is important)](#ensuring-prompt-execution)
-
-**Zsh**
-```zsh
-export PROMPT="$PROMPT\$(git-sonar --zsh --fetch) "
-```
-[(note: the `\` escaping the `$` is important)](#ensuring-prompt-execution)
-
You may also choose to fetch at a customized interval of time. To do so, add
this to your .bashrc, .zshrc:
@@ -254,14 +240,14 @@ to escape the execution of the function. There are two ways to do this:
**1. Use `$'` to render raw characters**
```bash
-export PROMPT=$'$(git-sonar --zsh)'
-export PS1=$'$(git-sonar --bash)'
+export PROMPT=$'$(git-sonar)'
+export PS1=$'$(git-sonar)'
```
**2. Use `\` to escape execution of the subshell**
```bash
-export PROMPT="\$(git-sonar --zsh)"
-export PS1="\$(git-sonar --bash)"
+export PROMPT="\$(git-sonar)"
+export PS1="\$(git-sonar)"
```
### Configuring colours
diff --git a/git-precheck b/git-precheck
new file mode 100755
index 0000000..9984bbb
--- /dev/null
+++ b/git-precheck
@@ -0,0 +1,94 @@
+#!/bin/sh
+
+usage() {
+ echo "git-precheck [--quiet] [--ignore-dirty] [--ignore-untracked]"
+ echo ""
+ echo "If the current working directory is inside a git repository, examine"
+ echo "the repo for any abnormal state and return an exit code indicating"
+ echo "the status. If unclean, print a line of text describing the"
+ echo "condition."
+ echo ""
+ echo " --quiet"
+ echo " Don't actually print anything."
+ echo ""
+ echo " --ignore-dirty"
+ echo " Don't consider the presence of uncommitted changes to tracked"
+ echo " files as an abnormal state."
+ echo ""
+ echo " --ignore-untracked"
+ echo " Don't consider the presence of untracked files as an abnormal"
+ echo " state."
+ echo ""
+ echo " Exit codes:"
+ echo " 0 If inside a repository and all checks return normal"
+ echo " 1 If untracked files detected"
+ echo " 2 If dirty/modified files detected"
+ echo " 3 If any ongoing git operation is in progress"
+ echo " 4 If not inside a git repository"
+ echo ""
+ echo " Exit any other value on error or if 'precheck' operation is"
+ echo " not completed, such as when viewing this help text."
+ exit 128
+}
+
+quiet=""
+ignore_dirty=""
+ignore_untracked=""
+
+while true; do
+ case "$1" in
+ --quiet) quiet="true" ;;
+ --ignore-dirty) ignore_dirty="true" ;;
+ --ignore-untracked) ignore_untracked="true" ;;
+ --help) usage ;;
+ -h) usage ;;
+ *) break
+ esac
+ shift
+done
+
+if [ $# -ne 0 ]; then
+ printf 'precheck: Unrecognized option given: %s\n' "$1"
+ exit 128
+fi
+
+check() {
+ if git rev-parse --verify "$1" >/dev/null 2>&1; then
+ [ -z "$quiet" ] && printf '\e[0;31m%s in progress\e[0m\n' "$2"
+ exit 3
+ fi
+}
+
+if ! [ "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = "true" ]; then
+ [ -z "$quiet" ] && printf '\e[0;31mNot inside a git work tree\e[0m\n'
+ exit 4
+fi
+
+check MERGE_HEAD Merge
+check REBASE_HEAD Rebase
+check REVERT_HEAD Revert
+check CHERRY_PICK_HEAD Cherry-pick
+check BISECT_EXPECTED_REV Bisect
+
+if [ -e "$(git rev-parse --git-path rebase-apply 2>/dev/null)" ]; then
+ [ -z "$quiet" ] && printf '\e[0;31mrebase-apply (am) found\e[0m\n'
+ exit 3
+fi
+
+if [ -z "$ignore_dirty" ]; then
+ if git status --porcelain 2>/dev/null \
+ | grep --quiet --invert-match '^??'; then
+ [ -z "$quiet" ] && printf '\e[0;31mModified files detected\e[0m\n'
+ exit 2
+ fi
+fi
+
+if [ -z "$ignore_untracked" ]; then
+ if git status --porcelain 2>/dev/null \
+ | grep --quiet '^??'; then
+ [ -z "$quiet" ] && printf '\e[0;31mUntracked files detected\e[0m\n'
+ exit 1
+ fi
+fi
+
+exit 0
diff --git a/git-sonar b/git-sonar
index 0a6c634..172529c 100755
--- a/git-sonar
+++ b/git-sonar
@@ -1,174 +1,79 @@
-#!/usr/bin/env bash
+#!/bin/sh
#
# git-sonar
#
# A heads up display for git
-GIT_SONAR_VERSION="v0.8"
-
-################################################################################
-# Original sonar-base
-################################################################################
-dot_git=""
-cwd=""
-remote=""
-rcfile_path="$HOME"
-
-get_fetch_time() {
- if [ -f "$rcfile_path/.gitradarrc.bash" ]; then
- source "$rcfile_path/.gitradarrc.bash"
- elif [ -f "$rcfile_path/.gitradarrc.zsh" ]; then
- source "$rcfile_path/.gitradarrc.zsh"
- elif [ -f "$rcfile_path/.gitradarrc" ]; then
- source "$rcfile_path/.gitradarrc"
- fi
-
- FETCH_TIME="${GIT_RADAR_FETCH_TIME:-"$((5 * 60))"}"
- echo "$FETCH_TIME"
-
-}
+GIT_SONAR_VERSION="v0.8.1"
prepare_colors() {
- if [ -f "$rcfile_path/.gitradarrc" ]; then
- source "$rcfile_path/.gitradarrc"
- fi
-
PRINT_F_OPTION=""
- COLOR_REMOTE_AHEAD="\x01${GIT_RADAR_COLOR_REMOTE_AHEAD:-"\\033[1;32m"}\x02"
- COLOR_REMOTE_BEHIND="\x01${GIT_RADAR_COLOR_REMOTE_BEHIND:-"\\033[1;31m"}\x02"
- COLOR_REMOTE_DIVERGED="\x01${GIT_RADAR_COLOR_REMOTE_DIVERGED:-"\\033[1;33m"}\x02"
- COLOR_REMOTE_NOT_UPSTREAM="\x01${GIT_RADAR_COLOR_REMOTE_NOT_UPSTREAM:-"\\033[1;31m"}\x02"
+ COLOR_REMOTE_AHEAD="\001${GIT_RADAR_COLOR_REMOTE_AHEAD:-"\\033[1;32m"}\002"
+ COLOR_REMOTE_BEHIND="\001${GIT_RADAR_COLOR_REMOTE_BEHIND:-"\\033[1;31m"}\002"
+ COLOR_REMOTE_DIVERGED="\001${GIT_RADAR_COLOR_REMOTE_DIVERGED:-"\\033[1;33m"}\002"
+ COLOR_REMOTE_NOT_UPSTREAM="\001${GIT_RADAR_COLOR_REMOTE_NOT_UPSTREAM:-"\\033[1;33m"}\002"
- COLOR_LOCAL_AHEAD="\x01${GIT_RADAR_COLOR_LOCAL_AHEAD:-"\\033[1;32m"}\x02"
- COLOR_LOCAL_BEHIND="\x01${GIT_RADAR_COLOR_LOCAL_BEHIND:-"\\033[1;31m"}\x02"
- COLOR_LOCAL_DIVERGED="\x01${GIT_RADAR_COLOR_LOCAL_DIVERGED:-"\\033[1;33m"}\x02"
+ COLOR_LOCAL_AHEAD="\001${GIT_RADAR_COLOR_LOCAL_AHEAD:-"\\033[1;32m"}\002"
+ COLOR_LOCAL_BEHIND="\001${GIT_RADAR_COLOR_LOCAL_BEHIND:-"\\033[1;31m"}\002"
+ COLOR_LOCAL_DIVERGED="\001${GIT_RADAR_COLOR_LOCAL_DIVERGED:-"\\033[1;33m"}\002"
- COLOR_CHANGES_STAGED="\x01${GIT_RADAR_COLOR_CHANGES_STAGED:-"\\033[1;32m"}\x02"
- COLOR_CHANGES_UNSTAGED="\x01${GIT_RADAR_COLOR_CHANGES_UNSTAGED:-"\\033[1;31m"}\x02"
- COLOR_CHANGES_CONFLICTED="\x01${GIT_RADAR_COLOR_CHANGES_CONFLICTED:-"\\033[1;33m"}\x02"
- COLOR_CHANGES_UNTRACKED="\x01${GIT_RADAR_COLOR_CHANGES_UNTRACKED:-"\\033[1;37m"}\x02"
+ COLOR_CHANGES_STAGED="\001${GIT_RADAR_COLOR_CHANGES_STAGED:-"\\033[1;32m"}\002"
+ COLOR_CHANGES_UNSTAGED="\001${GIT_RADAR_COLOR_CHANGES_UNSTAGED:-"\\033[1;31m"}\002"
+ COLOR_CHANGES_CONFLICTED="\001${GIT_RADAR_COLOR_CHANGES_CONFLICTED:-"\\033[1;33m"}\002"
+ COLOR_CHANGES_UNTRACKED="\001${GIT_RADAR_COLOR_CHANGES_UNTRACKED:-"\\033[1;37m"}\002"
- COLOR_STASH="\x01${GIT_RADAR_COLOR_STASH:-"\\033[1;33m"}\x02"
+ COLOR_CONDITION="\001${GIT_RADAR_COLOR_CONDITION:-"\\033[1;33m"}\002"
- COLOR_BRANCH="\x01${GIT_RADAR_COLOR_BRANCH:-"\\033[0m"}\x02"
- MASTER_SYMBOL="${GIT_RADAR_MASTER_SYMBOL:-"\\x01\\033[0m\\x02\\xF0\\x9D\\x98\\xAE\\x01\\033[0m\\x02"}"
+ COLOR_STASH="\001${GIT_RADAR_COLOR_STASH:-"\\033[1;33m"}\002"
- PROMPT_FORMAT="${GIT_RADAR_FORMAT:-" \\x01\\033[1;30m\\x02git:(\\x01\\033[0m\\x02%{remote: }%{branch}%{ :local}\\x01\\033[1;30m\\x02)\\x01\\033[0m\\x02%{ :stash}%{ :changes}"}"
+ COLOR_BRANCH="\001${GIT_RADAR_COLOR_BRANCH:-"\\033[0m"}\002"
+ MASTER_SYMBOL="${GIT_RADAR_MASTER_SYMBOL:-""}" # \\x01\\033[0m\\x02\\xF0\\x9D\\x98\\xAE\\x01\\033[0m\\x02
- RESET_COLOR_LOCAL="\x01${GIT_RADAR_COLOR_LOCAL_RESET:-"\\033[0m"}\x02"
- RESET_COLOR_REMOTE="\x01${GIT_RADAR_COLOR_REMOTE_RESET:-"\\033[0m"}\x02"
- RESET_COLOR_CHANGES="\x01${GIT_RADAR_COLOR_CHANGES_RESET:-"\\033[0m"}\x02"
- RESET_COLOR_BRANCH="\x01${GIT_RADAR_COLOR_BRANCH_RESET:-"\\033[0m"}\x02"
- RESET_COLOR_STASH="\x01${GIT_RADAR_COLOR_STASH_RESET:-"\\033[0m"}\x02"
+ PROMPT_FORMAT="${GIT_RADAR_FORMAT:-" \\001\\033[1;30m\\002git:(\\001\\033[0m\\002%{condition: }%{remote: }%{missingups}%{branch}%{ :local}\\001\\033[1;30m\\002)\\001\\033[0m\\002%{ :stash}%{ :changes}"}"
-}
+ RESET_COLOR_LOCAL="\001${GIT_RADAR_COLOR_LOCAL_RESET:-"\\033[0m"}\002"
+ RESET_COLOR_REMOTE="\001${GIT_RADAR_COLOR_REMOTE_RESET:-"\\033[0m"}\002"
+ RESET_COLOR_CHANGES="\001${GIT_RADAR_COLOR_CHANGES_RESET:-"\\033[0m"}\002"
+ RESET_COLOR_BRANCH="\001${GIT_RADAR_COLOR_BRANCH_RESET:-"\\033[0m"}\002"
+ RESET_COLOR_STASH="\001${GIT_RADAR_COLOR_STASH_RESET:-"\\033[0m"}\002"
+ RESET_COLOR_CONDITION="\001${GIT_RADAR_COLOR_CONDITION_RESET:-"\\033[0m"}\002"
-in_current_dir() {
- local wd
- wd="$(pwd)"
- if [[ "$wd" == "$cwd" ]]; then
- cwd="$wd"
- return 0
- else
- cwd="$wd"
- return 1
- fi
-}
-
-dot_git() {
- if in_current_dir && [[ -n "$dot_git" ]]; then
- # cache dot_git to save calls to rev-parse
- printf '%s' "$dot_git"
- elif [ -d .git ]; then
- dot_git=".git"
- printf '%s' $dot_git
- else
- dot_git="$(git rev-parse --git-dir 2>/dev/null)"
- printf '%s' "$dot_git"
- fi
}
is_repo() {
- if [[ -n "$(dot_git)" ]]; then
- return 0
- else
- return 1
- fi
-}
-
-record_timestamp() {
- if is_repo; then
- touch "$(dot_git)/lastupdatetime"
- fi
-}
-
-timestamp() {
- if is_repo; then
- if [[ $OSTYPE == darwin* ]];then
- printf '%s' "$(stat -f%m "$(dot_git)/lastupdatetime" 2>/dev/null || printf '%s' "0")"
- else
- printf '%s' "$(stat -c %Y "$(dot_git)/lastupdatetime" 2>/dev/null || printf '%s' "0")"
- fi;
-
- fi
-}
-
-time_now() {
- printf '%s' "$(date +%s)"
-}
-
-time_to_update() {
- last_time_updated="${1:-$FETCH_TIME}"
- if is_repo; then
- local timesincelastupdate="$(($(time_now) - $(timestamp)))"
- if (( $timesincelastupdate > $last_time_updated )); then
- # time to update return 0 (which is true)
- return 0
- else
- # not time to update return 1 (which is false)
- return 1
- fi
- else
- return 1
- fi
+ git-precheck --quiet
+ [ $? -lt 4 ]
}
fetch() {
- # Gives $FETCH_TIME a value
- get_fetch_time
+ FETCH_TIME="${GIT_RADAR_FETCH_TIME:-"$((5 * 60))"}"
+ TS_FILE="$(git rev-parse --git-path lastupdatetime 2>/dev/null)"
- if time_to_update "$FETCH_TIME"; then
- record_timestamp
+ now="$(date '+%s')"
+ timestamp="$(cat "$TS_FILE" 2>/dev/null)"
+ [ "$timestamp" -eq "$timestamp" ] >/dev/null 2>&1 || timestamp="0"
+
+ if [ "$((now - timestamp))" -ge "$FETCH_TIME" ]; then
nohup git fetch --quiet >/dev/null 2>&1 &
+ echo "$now" >"$TS_FILE"
fi
}
commit_short_sha() {
- if is_repo; then
- printf '%s' "$(git rev-parse --short HEAD 2>/dev/null)"
- fi
+ git rev-parse --short HEAD 2>/dev/null
}
branch_name() {
- name="$(git symbolic-ref --short HEAD 2>/dev/null)"
- retcode="$?"
- if [[ "$retcode" == "0" ]]; then
- printf %s "$name"
- else
- return 1
- fi
+ git symbolic-ref --short HEAD 2>/dev/null
}
remote_branch_name() {
- local localRef
- local remote
localRef="$(branch_name)"
- remote="$(git config --get "branch.$localRef.remote")"
- if [[ -n $remote ]]; then
- local remoteBranch
+ remote="$(git config --get "branch.${localRef}.remote")"
+ if [ -n "$remote" ]; then
remoteBranch="$(git config --get "branch.${localRef}.merge" | sed -e 's/^refs\/heads\///')"
- if [[ -n $remoteBranch ]]; then
+ if [ -n "$remoteBranch" ]; then
printf '%s/%s' "$remote" "$remoteBranch"
return 0
else
@@ -181,7 +86,7 @@ remote_branch_name() {
commits_behind_of_remote() {
remote_branch=${1:-"$(remote_branch_name)"}
- if [[ -n "$remote_branch" ]]; then
+ if [ -n "$remote_branch" ]; then
git rev-list --left-only --count "${remote_branch}...HEAD" 2>/dev/null
else
printf '%s' "0"
@@ -190,7 +95,7 @@ commits_behind_of_remote() {
commits_ahead_of_remote() {
remote_branch=${1:-"$(remote_branch_name)"}
- if [[ -n "$remote_branch" ]]; then
+ if [ -n "$remote_branch" ]; then
git rev-list --right-only --count "${remote_branch}...HEAD" 2>/dev/null
else
printf '%s' "0"
@@ -199,10 +104,10 @@ commits_ahead_of_remote() {
determine_tracked_remote() {
by_branch=$(git config --local branch."$(git rev-parse --abbrev-ref HEAD)".git-radar-tracked-remote)
- [[ ! -z "$by_branch" ]] && echo "$by_branch" && return 0
+ [ -n "$by_branch" ] && echo "$by_branch" && return 0
by_config=$(git config --local git-radar.tracked-remote)
- [[ ! -z "$by_config" ]] && echo "$by_config" && return 0
+ [ -n "$by_config" ] && echo "$by_config" && return 0
echo "origin/master"
}
@@ -210,7 +115,7 @@ determine_tracked_remote() {
remote_behind_of_master() {
remote_branch=${1:-"$(remote_branch_name)"}
tracked_remote=$(determine_tracked_remote)
- if [[ -n "$remote_branch" && "$remote_branch" != "$tracked_remote" ]]; then
+ if [ -n "$remote_branch" ] && [ "$remote_branch" != "$tracked_remote" ]; then
git rev-list --left-only --count "${tracked_remote}...${remote_branch}" 2>/dev/null || printf '%s' "0"
else
printf '%s' "0"
@@ -220,7 +125,7 @@ remote_behind_of_master() {
remote_ahead_of_master() {
remote_branch=${1:-"$(remote_branch_name)"}
tracked_remote=$(determine_tracked_remote)
- if [[ -n "$remote_branch" && "$remote_branch" != "$tracked_remote" ]]; then
+ if [ -n "$remote_branch" ] && [ "$remote_branch" != "$tracked_remote" ]; then
git rev-list --right-only --count "${tracked_remote}...${remote_branch}" 2>/dev/null || printf '%s' "0"
else
printf '%s' "0"
@@ -233,21 +138,15 @@ remote_ahead_of_master() {
#both="\xE2\x83\xA1%{$reset_color%}"
porcelain_status() {
- printf '%s' "$(git status --porcelain 2>/dev/null)"
+ git status --porcelain 2>/dev/null
}
staged_status() {
- local gitStatus=${1:-"$(porcelain_status)"}
- local prefix=${2:-""}
- local suffix=${3:-""}
-
- local staged_string=""
- local filesModified
- local filesAdded
- local filesDeleted
- local filesRenamed
- local filesCopied
- local typeChanged
+ gitStatus="${1:-"$(porcelain_status)"}"
+ prefix="${2:-""}"
+ suffix="${3:-""}"
+ staged_string=""
+
filesModified="$(printf '%s' "$gitStatus" | grep -oE "M[ACDRM ] " | wc -l | grep -oEi '[1-9][0-9]*')"
filesAdded="$(printf '%s' "$gitStatus" | grep -oE "A[MCDR ] " | wc -l | grep -oEi '[1-9][0-9]*')"
filesDeleted="$(printf '%s' "$gitStatus" | grep -oE "D[AMCR ] " | wc -l | grep -oEi '[1-9][0-9]*')"
@@ -277,14 +176,11 @@ staged_status() {
}
conflicted_status() {
- local gitStatus=${1:-"$(porcelain_status)"}
- local prefix=${2:-""}
- local suffix=${3:-""}
- local conflicted_string=""
-
- local filesUs
- local filesThem
- local filesBoth
+ gitStatus="${1:-"$(porcelain_status)"}"
+ prefix="${2:-""}"
+ suffix="${3:-""}"
+ conflicted_string=""
+
filesUs="$(printf '%s' "$gitStatus" | grep -oE "[AD]U " | wc -l | grep -oEi '[1-9][0-9]*')"
filesThem="$(printf '%s' "$gitStatus" | grep -oE "U[AD] " | wc -l | grep -oEi '[1-9][0-9]*')"
filesBoth="$(printf '%s' "$gitStatus" | grep -oE "(UU|AA|DD) " | wc -l | grep -oEi '[1-9][0-9]*')"
@@ -302,14 +198,11 @@ conflicted_status() {
}
unstaged_status() {
- local gitStatus=${1:-"$(porcelain_status)"}
- local prefix=${2:-""}
- local suffix=${3:-""}
- local unstaged_string=""
-
- local filesModified
- local filesDeleted
- local typeChanged
+ gitStatus="${1:-"$(porcelain_status)"}"
+ prefix="${2:-""}"
+ suffix="${3:-""}"
+ unstaged_string=""
+
filesModified="$(printf '%s' "$gitStatus" | grep -oE "[ACDRM ]M " | wc -l | grep -oEi '[1-9][0-9]*')"
filesDeleted="$(printf '%s' "$gitStatus" | grep -oE "[AMCR ]D " | wc -l | grep -oEi '[1-9][0-9]*')"
typeChanged="$(printf '%s' "$gitStatus" | grep -oE "[AMDR ]T " | wc -l | grep -oEi '[1-9][0-9]*')"
@@ -327,12 +220,11 @@ unstaged_status() {
}
untracked_status() {
- local gitStatus=${1:-"$(porcelain_status)"}
- local prefix=${2:-""}
- local suffix=${3:-""}
- local untracked_string=""
+ gitStatus="${1:-"$(porcelain_status)"}"
+ prefix="${2:-""}"
+ suffix="${3:-""}"
+ untracked_string=""
- local filesUntracked
filesUntracked="$(printf '%s' "$gitStatus" | grep "?? " | wc -l | grep -oEi '[1-9][0-9]*')"
if [ -n "$filesUntracked" ]; then
@@ -342,119 +234,110 @@ untracked_status() {
}
color_changes_status() {
- local separator="${1:- }"
-
- local porcelain
+ separator="${1:- }"
porcelain="$(porcelain_status)"
- local changes=""
+ changes=""
- if [[ -n "$porcelain" ]]; then
- local staged_changes
- local unstaged_changes
- local untracked_changes
- local conflicted_changes
+ if [ -n "$porcelain" ]; then
staged_changes="$(staged_status "$porcelain" "$COLOR_CHANGES_STAGED" "$RESET_COLOR_CHANGES")"
unstaged_changes="$(unstaged_status "$porcelain" "$COLOR_CHANGES_UNSTAGED" "$RESET_COLOR_CHANGES")"
untracked_changes="$(untracked_status "$porcelain" "$COLOR_CHANGES_UNTRACKED" "$RESET_COLOR_CHANGES")"
conflicted_changes="$(conflicted_status "$porcelain" "$COLOR_CHANGES_CONFLICTED" "$RESET_COLOR_CHANGES")"
- if [[ -n "$staged_changes" ]]; then
+ if [ -n "$staged_changes" ]; then
staged_changes="$separator$staged_changes"
fi
- if [[ -n "$unstaged_changes" ]]; then
+ if [ -n "$unstaged_changes" ]; then
unstaged_changes="$separator$unstaged_changes"
fi
- if [[ -n "$conflicted_changes" ]]; then
+ if [ -n "$conflicted_changes" ]; then
conflicted_changes="$separator$conflicted_changes"
fi
- if [[ -n "$untracked_changes" ]]; then
+ if [ -n "$untracked_changes" ]; then
untracked_changes="$separator$untracked_changes"
fi
changes="$staged_changes$conflicted_changes$unstaged_changes$untracked_changes"
fi
- printf $PRINT_F_OPTION "${changes:1}"
+ printf $PRINT_F_OPTION "${changes#"$separator"}"
}
color_local_commits() {
- local green_ahead_arrow="${COLOR_LOCAL_AHEAD}↑$RESET_COLOR_LOCAL"
- local red_behind_arrow="${COLOR_LOCAL_BEHIND}↓$RESET_COLOR_LOCAL"
- local yellow_diverged_arrow="${COLOR_LOCAL_DIVERGED}⇵$RESET_COLOR_LOCAL"
+ green_ahead_arrow="${COLOR_LOCAL_AHEAD}↑$RESET_COLOR_LOCAL"
+ red_behind_arrow="${COLOR_LOCAL_BEHIND}↓$RESET_COLOR_LOCAL"
+ yellow_diverged_arrow="${COLOR_LOCAL_DIVERGED}⇵$RESET_COLOR_LOCAL"
+ local_commits=""
- local local_commits=""
if remote_branch="$(remote_branch_name)"; then
local_ahead="$(commits_ahead_of_remote "$remote_branch")"
local_behind="$(commits_behind_of_remote "$remote_branch")"
- if [[ "$local_behind" -gt "0" && "$local_ahead" -gt "0" ]]; then
+ if [ "$local_behind" -gt 0 ] && [ "$local_ahead" -gt 0 ]; then
local_commits="$local_behind$yellow_diverged_arrow$local_ahead"
- elif [[ "$local_behind" -gt "0" ]]; then
+ elif [ "$local_behind" -gt 0 ]; then
local_commits="$local_behind$red_behind_arrow"
- elif [[ "$local_ahead" -gt "0" ]]; then
+ elif [ "$local_ahead" -gt 0 ]; then
local_commits="$local_ahead$green_ahead_arrow"
fi
fi
printf $PRINT_F_OPTION "$local_commits"
}
+color_missing_upstream() {
+ not_upstream="${COLOR_REMOTE_NOT_UPSTREAM}⚡$RESET_COLOR_REMOTE"
+
+ if remote_branch="$(remote_branch_name)"; then
+ if ! git rev-parse "$remote_branch" -- >/dev/null 2>&1; then
+ printf "$not_upstream"
+ fi
+ fi
+}
+
color_remote_commits() {
- local green_ahead_arrow="${COLOR_REMOTE_AHEAD}←$RESET_COLOR_REMOTE"
- local red_behind_arrow="${COLOR_REMOTE_BEHIND}→$RESET_COLOR_REMOTE"
- local yellow_diverged_arrow="${COLOR_REMOTE_DIVERGED}⇄$RESET_COLOR_REMOTE"
- local not_upstream="${COLOR_REMOTE_NOT_UPSTREAM}⚡$RESET_COLOR_REMOTE"
+ green_ahead_arrow="${COLOR_REMOTE_AHEAD}↑$RESET_COLOR_REMOTE" # "←"
+ red_behind_arrow="${COLOR_REMOTE_BEHIND}↓$RESET_COLOR_REMOTE" # "→"
+ yellow_diverged_arrow="${COLOR_REMOTE_DIVERGED}⇵$RESET_COLOR_REMOTE" # "⇄"
+ remote=""
if remote_branch="$(remote_branch_name)"; then
remote_ahead="$(remote_ahead_of_master "$remote_branch")"
remote_behind="$(remote_behind_of_master "$remote_branch")"
- if [[ "$remote_behind" -gt "0" && "$remote_ahead" -gt "0" ]]; then
- remote="$MASTER_SYMBOL $remote_behind $yellow_diverged_arrow $remote_ahead"
- elif [[ "$remote_ahead" -gt "0" ]]; then
- remote="$MASTER_SYMBOL $green_ahead_arrow $remote_ahead"
- elif [[ "$remote_behind" -gt "0" ]]; then
- remote="$MASTER_SYMBOL $remote_behind $red_behind_arrow"
+ if [ "$remote_behind" -gt 0 ] && [ "$remote_ahead" -gt 0 ]; then
+ remote="$MASTER_SYMBOL$remote_behind$yellow_diverged_arrow$remote_ahead"
+ elif [ "$remote_ahead" -gt 0 ]; then
+ remote="$MASTER_SYMBOL$green_ahead_arrow$remote_ahead"
+ elif [ "$remote_behind" -gt 0 ]; then
+ remote="$MASTER_SYMBOL$remote_behind$red_behind_arrow"
fi
- else
- remote="upstream $not_upstream"
fi
printf $PRINT_F_OPTION "$remote"
}
readable_branch_name() {
- if is_repo; then
- printf $PRINT_F_OPTION "$COLOR_BRANCH$(branch_name || printf '%s' "detached@$(commit_short_sha)")$RESET_COLOR_BRANCH"
- fi
+ printf $PRINT_F_OPTION "$COLOR_BRANCH$(branch_name || printf '%s' "detached@$(commit_short_sha)")$RESET_COLOR_BRANCH"
}
stashed_status() {
printf '%s' "$(git stash list | wc -l 2>/dev/null | grep -oEi '[0-9][0-9]*')"
}
-is_cwd_a_dot_git_directory() {
- if [[ "${1##*/}" == ".git" ]]; then
- return 0
- elif [[ -z $1 ]]; then
- return 1
- else
- is_cwd_a_dot_git_directory "${1%/*}"
+stash_status() {
+ number_stashes="$(stashed_status)"
+ if [ "$number_stashes" -gt 0 ]; then
+ printf $PRINT_F_OPTION "${number_stashes}${COLOR_STASH}≡${RESET_COLOR_STASH}"
fi
}
-stash_status() {
- if ! is_cwd_a_dot_git_directory "$PWD"; then
- local number_stashes
- number_stashes="$(stashed_status)"
- if [ "$number_stashes" -gt 0 ]; then
- printf $PRINT_F_OPTION "${number_stashes}${COLOR_STASH}≡${RESET_COLOR_STASH}"
- fi
- fi
+repo_special_condition() {
+ git-precheck --quiet --ignore-dirty --ignore-untracked \
+ || printf "$COLOR_CONDITION!$RESET_COLOR_CONDITION"
}
render_prompt() {
- output="$PROMPT_FORMAT"
branch_sed=""
remote_sed=""
local_sed=""
@@ -467,48 +350,66 @@ render_prompt() {
sed_pre="%{\(\([^%^{^}]*\)\:\)\{0,1\}"
sed_post="\(\:\([^%^{^}]*\)\)\{0,1\}}"
- if [[ $output =~ ${if_pre}remote${if_post} ]]; then
+ if echo "$PROMPT_FORMAT" | grep -qE "${if_pre}condition${if_post}"; then
+ condition_result="$(repo_special_condition)"
+ if [ -n "$condition_result" ]; then
+ condition_sed="s/${sed_pre}condition${sed_post}/\2${condition_result}\4/"
+ else
+ condition_sed="s/${sed_pre}condition${sed_post}//"
+ fi
+ fi
+ if echo "$PROMPT_FORMAT" | grep -qE "${if_pre}missingups${if_post}"; then
+ missingups_result="$(color_missing_upstream)"
+ if [ -n "$missingups_result" ]; then
+ missingups_sed="s/${sed_pre}missingups${sed_post}/\2${missingups_result}\4/"
+ else
+ missingups_sed="s/${sed_pre}missingups${sed_post}//"
+ fi
+ fi
+ if echo "$PROMPT_FORMAT" | grep -qE "${if_pre}remote${if_post}"; then
remote_result="$(color_remote_commits)"
- if [[ -n "$remote_result" ]]; then
+ if [ -n "$remote_result" ]; then
remote_sed="s/${sed_pre}remote${sed_post}/\2${remote_result}\4/"
else
remote_sed="s/${sed_pre}remote${sed_post}//"
fi
fi
- if [[ $PROMPT_FORMAT =~ ${if_pre}branch${if_post} ]]; then
+ if echo "$PROMPT_FORMAT" | grep -qE "${if_pre}branch${if_post}"; then
branch_result="$(readable_branch_name | sed -e 's/\//\\\//g')"
- if [[ -n "$branch_result" ]]; then
+ if [ -n "$branch_result" ]; then
branch_sed="s/${sed_pre}branch${sed_post}/\2${branch_result}\4/"
else
branch_sed="s/${sed_pre}branch${sed_post}//"
fi
fi
- if [[ $PROMPT_FORMAT =~ ${if_pre}local${if_post} ]]; then
+ if echo "$PROMPT_FORMAT" | grep -qE "${if_pre}local${if_post}"; then
local_result="$(color_local_commits)"
- if [[ -n "$local_result" ]]; then
+ if [ -n "$local_result" ]; then
local_sed="s/${sed_pre}local${sed_post}/\2$local_result\4/"
else
local_sed="s/${sed_pre}local${sed_post}//"
fi
fi
- if [[ $PROMPT_FORMAT =~ ${if_pre}changes${if_post} ]]; then
+ if echo "$PROMPT_FORMAT" | grep -qE "${if_pre}changes${if_post}"; then
changes_result="$(color_changes_status)"
- if [[ -n "$changes_result" ]]; then
+ if [ -n "$changes_result" ]; then
changes_sed="s/${sed_pre}changes${sed_post}/\2${changes_result}\4/"
else
changes_sed="s/${sed_pre}changes${sed_post}//"
fi
fi
- if [[ $PROMPT_FORMAT =~ ${if_pre}stash${if_post} ]]; then
+ if echo "$PROMPT_FORMAT" | grep -qE "${if_pre}stash${if_post}"; then
stash_result="$(stash_status)"
- if [[ -n "$stash_result" ]]; then
+ if [ -n "$stash_result" ]; then
stash_sed="s/${sed_pre}stash${sed_post}/\2${stash_result}\4/"
else
stash_sed="s/${sed_pre}stash${sed_post}//"
fi
fi
- printf '%b' "$output" | sed \
+ printf '%b' "$PROMPT_FORMAT" | sed \
+ -e "$condition_sed" \
+ -e "$missingups_sed" \
-e "$remote_sed" \
-e "$branch_sed" \
-e "$changes_sed" \
@@ -516,10 +417,6 @@ render_prompt() {
-e "$stash_sed"
}
-
-################################################################################
-# Original main
-################################################################################
usage() {
_git="\033[1;30mgit:(\033[0m"
_master="\033[0;37mmaster\033[0m"
@@ -529,38 +426,38 @@ usage() {
_added_staged="\033[1;32mA\033[0m"
_modified_unstaged="\033[1;31mM\033[0m"
_local_up="\033[1;32m↑\033[0m"
- _2_from_master="\xF0\x9D\x98\xAE 2 \033[1;31m→\033[0m "
- _diverged_from_master="\xF0\x9D\x98\xAE 2 \033[1;33m⇄\033[0m 3 "
+ _2_from_master="\360\235\230\256 2 \033[1;31m→\033[0m "
+ _diverged_from_master="\360\235\230\256 2 \033[1;33m⇄\033[0m 3 "
_not_upstream="upstream \033[1;31m⚡\033[0m "
_detached="\033[0;37mdetached@94eac67\033[0m"
_conflicted_us="\033[1;33mU\033[0m"
_conflicted_them="\033[1;33mT\033[0m"
- _ahead_master="\xF0\x9D\x98\xAE \033[1;32m←\033[0m"
+ _ahead_master="\360\235\230\256 \033[1;32m←\033[0m"
_local_diverged="\033[1;33m⇵\033[0m"
_stash="\033[1;33m≡\033[0m"
echo "git-sonar - a heads up display for git"
echo " $GIT_SONAR_VERSION"
echo ""
echo "examples:"
- echo -ne " $_git$_master$_endgit"
+ printf '%b' " $_git$_master$_endgit"
echo " # You are on the master branch and everything is clean"
- echo -ne " $_git$_not_upstream$_my_branch$_endgit"
+ printf '%b' " $_git$_not_upstream$_my_branch$_endgit"
echo " # Fresh branch that we haven't pushed upstream"
- echo -ne " $_git$_my_branch$_endgit 2$_untracked"
+ printf '%b' " $_git$_my_branch$_endgit 2$_untracked"
echo " # Two files created that aren't tracked by git"
- echo -ne " $_git$_my_branch$_endgit 1$_added_staged 3$_modified_unstaged"
+ printf '%b' " $_git$_my_branch$_endgit 1$_added_staged 3$_modified_unstaged"
echo " # 1 new file staged to commit and 3 modifications that we still need to \`git add\`"
- echo -ne " $_git$_2_from_master$_my_branch 3$_local_up$_endgit"
+ printf '%b' " $_git$_2_from_master$_my_branch 3$_local_up$_endgit"
echo " # 3 commits made locally ready to push up while master is ahead of us by 2"
- echo -ne " $_git$_diverged_from_master$_my_branch$_endgit"
+ printf '%b' " $_git$_diverged_from_master$_my_branch$_endgit"
echo " # our commits pushed up, master and my-branch have diverged"
- echo -ne " $_git$_detached$_endgit 2${_conflicted_them}3${_conflicted_us}"
+ printf '%b' " $_git$_detached$_endgit 2${_conflicted_them}3${_conflicted_us}"
echo " # mid rebase, we are detached and have 3 conflicts caused by US and 2 caused by THEM"
- echo -ne " $_git$_diverged_from_master$_my_branch 3${_local_diverged}5$_endgit"
+ printf '%b' " $_git$_diverged_from_master$_my_branch 3${_local_diverged}5$_endgit"
echo " # rebase complete, our rewritten commits now need pushed up"
- echo -ne " $_git$_ahead_master 3 $_my_branch$_endgit"
+ printf '%b' " $_git$_ahead_master 3 $_my_branch$_endgit"
echo " # origin/my-branch is up to date with master and has our 3 commits waiting merge"
- echo -ne " $_git$_master$_endgit 3$_stash"
+ printf '%b' " $_git$_master$_endgit 3$_stash"
echo " # You have 3 stashes stored"
echo ""
@@ -572,23 +469,39 @@ usage() {
echo " --zsh # (does nothing - for compatibility with git-radar)"
echo " --bash # (does nothing - for compatibility with git-radar)"
echo " --fish # (does nothing - for compatibility with git-radar)"
-}
-
-while [[ $# -gt 0 ]]; do
- command="$1"
+ exit
+}
+
+do_fetch=""
+
+while true; do
+ case "$1" in
+ --help) usage ;;
+ -h) usage ;;
+ --fetch) do_fetch="true" ;;
+ -f) do_fetch="true" ;;
+ --zsh) ;;
+ --bash) ;;
+ --fish) ;;
+ *) break
+ esac
shift
-
- if [[ "$command" == "-h" ]] || [[ "$command" == "--help" ]]; then
- usage
- exit
- fi
-
- if [[ "$command" == "-f" ]] || [[ "$command" == "--fetch" ]]; then
- fetch >/dev/null 2>&1
- fi
done
+if [ $# -ne 0 ]; then
+ printf 'sonar: Unrecognized option given: %s\n' "$1"
+ exit 1
+fi
+
+# Guard all active operations by this is_repo check
if is_repo; then
+ # Merge configuration from accepted RC files
+ [ -f "$HOME/.gitradarrc" ] && . "$HOME/.gitradarrc"
+ [ -f "$HOME/.gitradarrc.bash" ] && . "$HOME/.gitradarrc.bash"
+ [ -f "$HOME/.gitradarrc.zsh" ] && . "$HOME/.gitradarrc.zsh"
+ [ -f "$HOME/.gitsonarrc" ] && . "$HOME/.gitsonarrc"
+
+ [ -n "$do_fetch" ] && fetch >/dev/null 2>&1
prepare_colors
render_prompt
fi